#ifndef __KEYS_H__ //avoid double inclusion
#define __KEYS_H__

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include "types.h"

#define	XTAL		F_CPU

#define KEY_PIN		PINE
#define KEY0		7
#define KEY1		6
#define KEY2		5

#define SELECT KEY0
#define DOWN   KEY1
#define UP     KEY2

#define REPEAT_MASK	(1<<KEY0^1<<KEY1^1<<KEY2)	// repeat: key0..key2
#define REPEAT_START	50		// after 500ms
#define REPEAT_NEXT	    20		// every 200ms

/* prototypes */
u08 get_key_press( u08 key_mask );
u08 get_key_rpt( u08 key_mask );
u08 get_key_short( u08 key_mask );
u08 get_key_long( u08 key_mask );
void keys_Init( void );

#endif //__KEYS_H__
