#ifndef __LCD_H__ //avoid double inclusion
#define __LCD_H__

#include "types.h"

#define LCD_DATA_PORT     PORTA
#define LCD_DATA_PORT_DDR DDRA
#define LCD_FUNC_PORT     PORTD
#define LCD_FUNC_PORT_DDR DDRD
#define LCD_RS_PIN      PD0
#define LCD_RW_PIN      PD1
#define LCD_E_PIN       PD2
#define LCD_LINE_LENGTH 20
#define LCD_LINES       2

#define LCD_INIT_FUNCTIONSET 0x38  //function set, 8bit interface, 2 lines
#define LCD_INIT_DISPLAY     0x0f  //display on, cursor on, blink on
#define LCD_INIT_CLEAR       0x01  //clear display
#define LCD_INIT_ENTRYMODE   0x06  //entry mode, incr. cursor shift

#define LCD_DELAY	asm volatile ("nop"); asm volatile ("nop")
#define LCD_BUSY        7          // DB7: LCD is busy

#define lcd_e_cycle()   _delay_us(10); \
                        sbi(LCD_FUNC_PORT,LCD_E_PIN); \
                        _delay_us(10); \
                        cbi(LCD_FUNC_PORT,LCD_E_PIN); \
                        _delay_us(10);
#define lcd_e_high()    LCD_DELAY; \
                        LCD_DELAY; \
                        sbi(LCD_FUNC_PORT,LCD_E_PIN); \
                        LCD_DELAY; \
                        LCD_DELAY;
#define lcd_e_low()     cbi(LCD_FUNC_PORT,LCD_E_PIN); \
                        LCD_DELAY; \
                        LCD_DELAY;

/* prototypes */
//void lcd_command(u08 cmd);
//void lcd_data(u08 cmd);
void lcd_gotoxy(u08 x, u08 y);
void lcd_clrscr(void);
void lcd_putchar(u08 data);
void lcd_puthex(u08 data);
void lcd_puts(u08* str);
//void lcd_puts_p(u08* p);
void lcd_home(void);
void lcd_write(u08 data, u08 rs);
void lcd_Init(void);
void lcd_loadCustomChar(u08* lcdCustomCharArray, u08 romCharNum, u08 lcdCharNum);
#endif // __LCD_H__

