#include "relais.h"
#include "lcd.h"

u08 device_state[8] = {0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff}; //8 possible devices

void initRelais()
{
    u08 i;
    //store state off 8 possible devices in RAM
    for(i=0;i<8;i++)
	   device_state[i] = i2c_GetByte(I2C_SLAVE_BASE | ((i << 1) & 0x0f));
}

void setRelais(u08 device, u08 nb)
{
	device_state[device] &= ~(1 << nb);
	i2c_SendByte(I2C_SLAVE_BASE | ((device << 1) & 0x0f), device_state[device]);
}

void releaseRelais(u08 device, u08 nb)
{
    device_state[device] |= (1 << nb);
	i2c_SendByte(I2C_SLAVE_BASE | ((device << 1) & 0x0f), device_state[device]);
}	 

bool isRelaisSet(u08 device,u08 nb)
{
	return(((device_state[device] >> nb) & 0x01) == 0x00);
}

void changeRelais(u08 device,u08 nb)
{
    if(isRelaisSet(device,nb))
      releaseRelais(device,nb);
    else
	  setRelais(device,nb);
}
